#include <eikenv.h>
#include <eikapp.h>
#include <eikappui.h>
#include <stdio.h>

#include <eikapp.h>
#include <e32base.h>
#include <sdlapp.h>
#include <BAUTILS.H>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

char KExultPath[256];
char KBlackGatePath[256];
char KSerpentIslePath[256];
	

class CExultApp: public CSDLApp {
public:
	CExultApp();
   	~CExultApp();
#ifdef UIQ3	
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 	 * @return TInt, resource id
   	*/
	TInt ViewResourceId();
#endif	
	/**
	 * This has a default empty implementation.
	 * Is called just before SDL_Main is called to allow init of system vars
	 */
	virtual	void PreInitializeAppL();

	TUid AppDllUid() const;

};


CApaApplication* NewApplication() {
	// Return pointer to newly created CQMApp
	return new CExultApp;
}

#include <eikstart.h>
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}


CExultApp::CExultApp() {
}

CExultApp::~CExultApp() {
}
#ifdef UIQ3
#include <Exult.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CExultApp::ViewResourceId() {
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif
FILE* mystdout = NULL;
FILE *mystderr = NULL;
/**
 * This has a default empty implementation.
 * Is called just before SDL_Main is called to allow init of system vars
 */
void CExultApp::PreInitializeAppL()
{
	TFileName filename;
	TPtr8 ptr((unsigned char*) KExultPath, 0, 255);
#ifdef UIQ3
	mystdout = fopen("c:\\shared\\Exult\\stdout.txt","w+");
	mystderr = fopen("c:\\shared\\Exult\\stderr.txt","w+");
#else
	mystdout = fopen("c:\\data\\Exult\\stdout.txt","w+");
	mystderr = fopen("c:\\data\\Exult\\stderr.txt","w+");
#endif
	*stderr = *mystdout;
	*stdout = *mystderr;
#ifdef UIQ3
	ptr.Copy(_L8("c:\\shared\\Exult"));
#else
	ptr.Copy(_L8("c:\\data\\Exult"));
#endif
	ptr.ZeroTerminate();
	setenv((const char*) "HOME", (const char*) ptr.PtrZ(), 1);
	chdir((char*)ptr.PtrZ());
	strcpy(KBlackGatePath, (char*) ptr.PtrZ());
	strcat(KBlackGatePath, "\\blackgate");
	strcpy(KSerpentIslePath, (char*) ptr.PtrZ());
	strcat(KSerpentIslePath, "\\serpentisle");
	
	filename = _L("C:\\Exult\\");
	for(TInt i = 'D';i<'Z';i++)
	{
		filename[0] = i;
		if(BaflUtils::PathExists(CEikonEnv::Static()->FsSession(), filename))
		{
			ptr.Copy(filename);
			ptr.ZeroTerminate();
			filename.Append(_L("blackgate\\"));
			if(BaflUtils::PathExists(CEikonEnv::Static()->FsSession(), filename))
				{
				strcpy(KBlackGatePath, (char*) ptr.PtrZ());
				strcat(KBlackGatePath, "blackgate");
				}
			filename.Copy(ptr);
			filename.Append(_L("serpentisle\\"));
			if(BaflUtils::PathExists(CEikonEnv::Static()->FsSession(), filename))
				{
				strcpy(KSerpentIslePath, (char*) ptr.PtrZ());
				strcat(KSerpentIslePath, "serpentisle");
				}
			
			chdir((char*)ptr.PtrZ());
			return;
		}
	}
	
}

/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CExultApp::AppDllUid() const {
	return TUid::Uid(0xA000A007);
}

/////////////////////////////////////////////////////////////////////////////////////////////////



